import pickle

import numpy as np

import matplotlib.pyplot as plt


def add_parser(subparsers):

    # The filter subparser.
    view_subparser = subparsers.add_parser(
        'view',
        description='Displays the inverse problem results.',
        help='View inverse problem results')
    view_subparser.add_argument(
        'results_filename', metavar='<results>', type=str,
        help='The file that contains the results of the inverse problem. '
             'Usually this is the output file generated by \'cimem solve\'')

    view_subparser.set_defaults(func=view)


def view(results_filename: str):
    """Displays the inverse problem results.

    Args:
        results_filename: The file that contains the results of the inverse
            problem. Usually this is the output file generated by
            'cimem solve'.

    """

    with open(results_filename, 'rb') as f:
        results = pickle.load(f)

    # Display the data fit.
    data = results['data']
    forward = results['forward']
    recovered_data = np.dot(forward, results['source_intensities'])

    plt.figure(figsize=(10, 5), dpi=150)
    plt.plot(data.T, 'ko-')
    plt.plot(recovered_data.T, 'r.', markersize=5)
    plt.xlabel('Samples')
    plt.ylabel('Amplitude')
    plt.show()

    # Display the posterior states of clusters.
    cost = results['cost']
    clusters = results['clusters']

    names = {}
    probabilities = []
    samples = []
    labels = []
    i = 0
    for cluster in clusters:
        if cluster.name not in names:
            names[cluster.name] = i
            i = i + 1
        labels.append(names[cluster.name])
        samples.append(cluster.sample)
        probabilities.append(1 - cost.marginals[cluster].probabilities[0])

    plt.figure(figsize=(10, 5), dpi=150)
    plt.scatter(samples, labels, 1.0,  c=probabilities)
    plt.colorbar()
    plt.xlabel('Samples')
    plt.ylabel('Clusters')
    plt.show()
